
#include <Servo.h>

Servo myservo;  // creamos un objeto servo

#define trigPin 2
// este numero se correspondera al pin que vamos a usar para disparar nuestra señal
#define echoPin 3
// este numero se correspondera al pin que vamos a usar para escuchar el eco de la señal que habiamos disparado
#define lEDPin1 12
#define lEDPin2 13
#define rangoAlcance 100 
// definimos el rango en el que queremos detectar movimiento
const int pinBuzzer = 9;


void setup() {
  Serial.begin (9600);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(lEDPin1, OUTPUT);
  pinMode(lEDPin2, OUTPUT);
  myservo.attach(5);
}
void loop()  {
  //si el sensor detecta movimiento = leds encendidos + motor parado
  //si sensor no detecta movimiento= leds apagados + motor girando + buzzer encendido

  int duracion, distancia; 
  // definimos dos variables locales


  digitalWrite(trigPin, HIGH); 
  //  le dicimos que dispare (HIGH) por el pin de disparo o sea que el el pin del trigger emita un pulso (digitalWrite)
  // cuando esto sucede, nuestro sensor emite pulsos rapidos a 40KHz (frecuencia no audible por los humanos) y espera el eco

  digitalWrite(trigPin, LOW);

  duracion = pulseIn(echoPin, HIGH);
  // Para calcular la duracion  definimos una variable con una funcion que calcula el tiempo que ha tardado un pulso en cambiar de Alto a Bajo o viceversa.
  // Esta funcion devuelve la anchura del pulso en microsegundos.

  distancia = (duracion / 2) / 29.1; 
  // aplicando la formula de la distancia = velocidad del sonido cm/us por  la duracion encalculada con el PulseIn obtendremos la distancia en centimetros

  if (distancia >= rangoAlcance || distancia <= 0) 
  // en caso  que  este fuera de rango, es decir, que no detecte movimiento en el rango definido realizara lo siguiente:

  {
    
    digitalWrite(lEDPin1, LOW);      //leds apagados
    digitalWrite (lEDPin2, LOW);
    myservo.write(180);              // se activa el servo para empezar a jugar, se gira
    delay(2000);
    tone(pinBuzzer, 600);            // buzzer avisando de que va a volver a la posicion inicial
    delay(500);
    noTone(pinBuzzer);
    delay(500);
    tone(pinBuzzer, 523, 300);
    delay(500);
    myservo.write(0);                // se activa el servo para volver a la posicion inicial
    delay(2000);
  }
  
  else
  
  {
    // en caso de que no este fuera de rango, es decir, que detecte movimiento en el rango definido realizara lo siguiente:

    digitalWrite(lEDPin1, HIGH);     //leds encendidos, informa que los jugadores han perdido
    digitalWrite (lEDPin2, HIGH);
    delay (5000);
    digitalWrite(lEDPin1, LOW);      //leds apagados, se ha terminado el juego y vuelve a empezar la partida
    digitalWrite (lEDPin2, LOW);
  }
  
}
